--------------------------------------------------
-- Player Classes Script by Unreal Software     --
-- 28.02.2009 - www.UnrealSoftware.de           --
-- Adds Player Classes to your server           --
--------------------------------------------------

if sample==nil then sample={} end
sample.classes={}

-----------------------
-- INITIAL SETUP     --
-----------------------
function initArray(m)
	local array = {}
	for i = 1, m do
		array[i]=0
	end
	return array
end
sample.classes.class=initArray(32)
function sample.classes.classmenu(id)
	menu(id,"Select your Class!,Soldier|M4A1,Heavy|M249,Pyro|Flamethrower,Sniper|Scout,Spy|Stealth armor,Engineer|Wrench,Demoman|Grenade launcher,Medic|Medic's claws,Vampire|Gets HP for each hit")	
end


-----------------------
-- TEAM -> CLASS     --
-----------------------
addhook("team","sample.classes.team")
function sample.classes.team(id,team)
	if (team>0) then
		sample.classes.classmenu(id)
	end
end


-----------------------
-- SERVERACTION      --
-----------------------
addhook("serveraction","sample.classes.serveraction")
function sample.classes.serveraction(id)
	sample.classes.classmenu(id)
end


-----------------------
-- CLASS SELECTION   --
-----------------------
addhook("menu","sample.classes.menu")
function sample.classes.menu(id,menu,sel)
	if (menu=="Select your Class!") then
		if (sel>=0 and sel<=10) then
			sample.classes.class[id]=sel
			if (player(id,"health")>0) then
				parse("killplayer "..id)
			end
		end
	end
end


-----------------------
-- SPAWN             --
-----------------------
addhook("spawn","sample.classes.spawn")
function sample.classes.spawn(id)
	-- SOLDIER
	if (sample.classes.class[id]<=1) then

          freeimage(id) 
          id1=image("gfx/sprites/wave.bmp",0,0,100+id) 
          imagescale(id1,1,1) 
          imageblend(id1,1) 
          imagealpha(id1,1) 
          if (player(id,"team") == 2) then 
               imagecolor(id1,0,0,0) 
                
          elseif (player(id,"team") == 1) then 
               imagecolor(id1,0,0,0) 
          end  

		parse ("setmaxhealth "..id.." 150")
		parse ("setarmor "..id.." 201")
		parse ("speedmod "..id.." 1")
		msg2(id,"205255205Current Class: Soldier")
		return "32,3,51,52";
	end
	-- HEAVY
	if (sample.classes.class[id]==2) then

          freeimage(id) 
          id1=image("gfx/sprites/flare2.bmp",0,0,100+id) 
          imagescale(id1,1,1) 
          imageblend(id1,1) 
          imagealpha(id1,0.7) 
          if (player(id,"team") == 2) then 
               imagecolor(id1,0,0,255) 
                
	elseif (player(id,"team") == 1) then 
               imagecolor(id1,255,0,0) 

          end 

		parse ("setmaxhealth "..id.." 150")
		parse ("setarmor "..id.." 203")
		parse ("speedmod "..id.." -10")
		parse ("strip "..id.." 50")
		parse ("setweapon "..id.." 5")
		msg2(id,"205255205Current Class: Heavy")
		return "40,5";
	end
	-- PYRO
	if (sample.classes.class[id]==3) then

          freeimage(id) 
          id1=image("gfx/sprites/flare3.bmp",0,0,100+id) 
          imagescale(id1,1,1) 
          imageblend(id1,1) 
          imagealpha(id1,0.5) 
          if (player(id,"team") == 2) then 
               imagecolor(id1,0,0,255) 
                
          elseif (player(id,"team") == 1) then 
               imagecolor(id1,255,0,0) 
          end 

		parse ("setmaxhealth "..id.." 125")
		parse ("setarmor "..id.." 200")
		parse ("speedmod "..id.." -5")
		msg2(id,"205255205Current Class: Pyromaniac")
		return "46,6,73";
	end
	-- SNIPER
	if (sample.classes.class[id]==4) then

          freeimage(id) 
          id1=image("gfx/sprites/flare3.bmp",0,0,100+id) 
          imagescale(id1,1,1) 
          imageblend(id1,1) 
          imagealpha(id1,0.7) 
          if (player(id,"team") == 2) then 
               imagecolor(id1,255,255,255) 
                
          elseif (player(id,"team") == 1) then 
               imagecolor(id1,255,255,255) 
                
          end 

		parse ("setmaxhealth "..id.." 100")
		parse ("setarmor "..id.." 100")
		parse ("strip "..id.." 50")
		msg2(id,"205255205Current Class: Sniper")
		return "34,3,53,69";
	end
	-- SPY
	if (sample.classes.class[id]==5) then

          freeimage(id) 
          id1=image("gfx/sprites/flare2.bmp",0,0,100+id) 
          imagescale(id1,1,1) 
          imageblend(id1,1) 
          imagealpha(id1,0.7) 
          if (player(id,"team") == 2) then 
               imagecolor(id1,0,0,0) 
                
          elseif (player(id,"team") == 1) then 
               imagecolor(id1,0,0,0) 
          end 

		parse ("setmaxhealth "..id.." 100")
		parse ("setarmor "..id.." 206")
		parse ("speedmod "..id.." 10")
		msg2(id,"205255205Current Class: Spy")
		return "1,21,72,76";
	end
	-- ENGINEER
	if (sample.classes.class[id]==6) then

          freeimage(id) 
          id1=image("gfx/sprites/flare2.bmp",0,0,100+id) 
          imagescale(id1,1,1) 
          imageblend(id1,1) 
          imagealpha(id1,0.7) 
          if (player(id,"team") == 2) then 
               imagecolor(id1,0,0,0) 
                
          elseif (player(id,"team") == 1) then 
               imagecolor(id1,0,0,0)  
          end 
         
		parse ("setmaxhealth "..id.." 80")
		parse ("setarmor "..id.." 120")
		parse ("speedmod "..id.." 3")
		parse ("strip "..id.." 50")
		msg2(id,"205255205Current Class: Engineer")
		return "10,4,74,85";
	end
	-- DEMOMAN
	if (sample.classes.class[id]==7) then

          freeimage(id) 
          id1=image("gfx/sprites/flare2.bmp",0,0,100+id) 
          imagescale(id1,1,1) 
          imageblend(id1,1) 
          imagealpha(id1,0.7) 
          if (player(id,"team") == 2) then 
               imagecolor(id1,0,0,0) 
                
          elseif (player(id,"team") == 1) then 
               imagecolor(id1,0,0,0) 
          end 

		parse ("setmaxhealth "..id.." 80")
		parse ("setarmor "..id.." 202")
		parse ("speedmod "..id.." -2")
		msg2(id,"205255205Current Class: Demoman")
		return "49,6,77";
	end
	-- MEDIC
	if (sample.classes.class[id]==8) then

          freeimage(id) 
          id1=image("gfx/sprites/wave.bmp",0,0,100+id) 
          imagescale(id1,1,1) 
          imageblend(id1,1) 
          imagealpha(id1,1) 
          if (player(id,"team") == 2) then 
               imagecolor(id1,0,0,255) 
                
          elseif (player(id,"team") == 1) then 
               imagecolor(id1,255,0,0) 
          end 

		parse ("setmaxhealth "..id.." 60")
		parse ("setarmor "..id.." 204")
		parse ("speedmod "..id.." 5")
		parse ("strip "..id.." 50")
		msg2(id,"205255205Current Class: Medic. Use Claws to heal")
		return "20,5,78";
	end

	-- Vampire
	if (sample.classes.class[id]==9) then

          freeimage(id) 
          id1=image("gfx/sprites/wave.bmp",0,0,100+id) 
          imagescale(id1,1,1) 
          imageblend(id1,1) 
          imagealpha(id1,1) 
          if (player(id,"team") == 2) then 
               imagecolor(id1,0,0,255) 
                
          elseif (player(id,"team") == 1) then 
               imagecolor(id1,255,0,0) 
          end 

		parse ("setmaxhealth "..id.." 80")
		parse ("sethealth "..id.." 80")
		parse ("setarmor "..id.." 80")
		parse ("speedmod "..id.." 6")
		msg2(id,"205255205Current Class: Vampire")

		return "39,75,53,2";
	end
end

--Claws Heal
addhook("hit","TMP_heal") 
function TMP_heal(id,source,weapon,hpdmg,apdmg) 
	if (weapon == 78) then 
		parse ("sethealth "..id.." "..player(id,"health")+20)
		parse("sv_sound \"letsrock/Heal.wav\"") 
		return 1
	end
end

--Vampire script
addhook("hit","hitt")
function hitt(vic,id)
	if (sample.classes.class[id]==9) then
		if (player(id,"health") == player(id,"maxhealth")) then
		parse("setmaxhealth "..id.." "..player(id,"health")+2)
		end	
	parse("sethealth "..id.." "..player(id,"health")+2)
	end
end 

addhook("kill","kil")
function kil(id)
     if (sample.classes.class[id] == 9) then
		if (player(id,"health") == player(id,"maxhealth")) then
		parse("setmaxhealth "..id.." "..player(id,"health")+2)
		end
          parse("sethealth "..id.." "..(player(id,"health")+2))
     end
end 

-----------------------
-- NO BUYING         --
-----------------------
addhook("buy","sample.classes.buy")
function sample.classes.buy()
	return 1
end

-----------------------
-- NO COLLECTING     --
-----------------------
addhook("walkover","sample.classes.walkover")
function sample.classes.walkover(id,iid,type)
	if (type>=61 and type<=68) then
		return 0

	elseif (type==86) then
		return 0
	end
	return 1
end


-----------------------
-- NO DROPPING       --
-----------------------
addhook("drop","sample.classes.drop")
function sample.classes.drop()
	return 1
end


-----------------------
-- NO DEAD DROPPING  --
-----------------------
addhook("die","sample.classes.die")
function sample.classes.die()
	return 1
end
